<?php
ini_set("memory_limit","1024M");
require_once '../bootstrap/bootstrap.php';
$entityManger = $instanceManager->getService('entityManager');
$entityManger->getConfiguration()->addFilter("logicalDelete", "\\Zeedhi\\DevOps\\Util\\LogicalDeleted");
$entityManger->getFilters()->enable("logicalDelete");
date_default_timezone_set('America/Sao_Paulo');
/** @var \Zeedhi\Framework\Application $application */
$application = $instanceManager->getService('application');
class script
{
    public static function setTree($entityManager)
    {
        $sql = "UPDATE TASK SET TREE_KEY = null";
        $entityManager->getConnection()->exec($sql);
        $sql = "UPDATE PROJECT SET TREE_KEY = null";
        $entityManager->getConnection()->exec($sql);

        $repositoryProject = $entityManager->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Project');
        $taskRepository = $entityManager->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Task');

        $result = $repositoryProject->findBy(array('parent' => null));
        self::treeRecursiva($result, $repositoryProject, $taskRepository,$entityManager);
        $entityManager->flush();
        echo "Fim\n";
    }

    /**
     * @param \Zeedhi\DevOps\Model\Projectmanagement\Entities\Project[] $result
     * @param $repositoryProject
     * @param $entityManager
     */
    public static function treeRecursiva($result, $repositoryProject, $taskRepository,$entityManager)
    {

        foreach ($result as $object) {
            $className = get_class($object);
            $id = $object->getId();
            //echo "Class {$className}  id: {$id}\n";
            $projects = array();
            $object->setUpdatedAt(new \DateTime());
            $entityManager->persist($object);
            if($object instanceof \Zeedhi\DevOps\Model\Projectmanagement\Entities\Project){
                $projects = $repositoryProject->findBy(array('parent' => $object->getId()));
                $tasks = $taskRepository->findBy(array('project' => $object->getId(), 'parent' => null));
            }else{
                $tasks = $taskRepository->findBy(array('parent' => $object->getId()));
            }
           self::treeRecursiva(array_merge($projects, $tasks), $repositoryProject, $taskRepository,$entityManager);
        }
    }
}
// mudar também no subscriber linha 53 (|| true)e 66(&& false)
    script::setTree($entityManger);


//$application->run();